//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once

#ifndef __APP_H__
#define __APP_H__


//////////////////// Includes /////////////////////////////////////////////////

#include "ntserv.h"


//////////////////// Classes //////////////////////////////////////////////////

class CMyService : public CNTService
{
public:
//Constructors / Destructors
  CMyService();
  CMyService(const CMyService&) = delete;
  CMyService(CMyService&&) = delete;
  ~CMyService() = default; //NOLINT(modernize-use-override)

//Methods
  CMyService& operator=(const CMyService&) = delete;
  CMyService& operator=(CMyService&&) = delete;
  void WINAPI ServiceMain(_In_ DWORD dwArgc, _In_opt_ LPTSTR* pszArgv) override;
  void OnStop() noexcept override;
  void OnPause() noexcept override;
  void OnContinue() noexcept override;
  void ShowHelp() noexcept override;
  void OnUserDefinedRequest(_In_ DWORD dwControl) override;

protected:
//Member variables
  std::atomic<bool> m_bWantStop;
  std::atomic<bool> m_bPaused;
  DWORD m_dwBeepInternal;
};

#endif //#ifndef __APP_H__
